#include "Timer.h"

long Timer::value(void)
{
  struct timeval diff = get();
  return diff.tv_usec+diff.tv_sec*1000000;
}

struct timeval Timer::get(void)
{
  if (running) gettimeofday(&end, 0);

  struct timeval diff = end;
  if (diff.tv_usec < begin.tv_usec)
  {
    --diff.tv_sec;
    diff.tv_usec += 1000000;
  }
  diff.tv_sec  -= begin.tv_sec;
  diff.tv_usec -= begin.tv_usec;

  return diff;
}
//end difference()

ostream& operator<<(ostream& stream, Timer& t)
{
  struct timeval diff = t.get();
  long microseconds = diff.tv_usec;
  long seconds      = diff.tv_sec;
  long minutes      = seconds / 60;
  seconds %= 60;
  long hours        = minutes / 60;
  minutes %= 60;
  long days         = hours / 24;
  hours %= 24;
  return stream << days << 'd' << hours << 'h' << minutes << 'm' << seconds << 's'
                << microseconds << "µs"; 
}
//end operator<<
